searchNodes=[{"ref":"Inject.html","title":"Inject","type":"module","doc":""},{"ref":"Inject.html#i/1","title":"Inject.i/1","type":"function","doc":""},{"ref":"Inject.html#inject/1","title":"Inject.inject/1","type":"function","doc":""},{"ref":"Inject.html#register/3","title":"Inject.register/3","type":"function","doc":""},{"ref":"Inject.Application.html","title":"Inject.Application","type":"module","doc":""},{"ref":"Inject.Application.html#start/2","title":"Inject.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"readme.html","title":"Inject","type":"extras","doc":"Inject Inject is a library that lets you write testable Elixir code that can run concurrently in ExUnit."},{"ref":"readme.html#installation","title":"Inject - Installation","type":"extras","doc":"def deps do [ {:inject, &quot;~&gt; 0.3.0&quot;} ] end It is recommended to disable inject in prod.exs to avoid any performance penalty for registry lookups. config :inject, disabled: true"},{"ref":"readme.html#usage","title":"Inject - Usage","type":"extras","doc":"Inject is just a couple of functions. inject/1 aliased as i/1. Use this function in your implementation code to flag modules for potential injection. defmodule MyApplication do import Inject, only: [i: 1] def process do {:ok, file} = i(File).open(&quot;your-mind.txt&quot;, []) ... end end register/2 register/3. Use this function in your tests to register a stubbed implementation for a module. defmodule MyApplicationTest do use ExUnit.Case, async: true import Inject, only: [register: 2] defmodule FileStub do def open(&quot;your-mind.txt&quot;, _opts) do {:ok, nil} end end test &quot;use my stub for this test&quot; do register(File, FileStub) {:ok, nil} = MyApplication.process() end end Defining stubbed modules like this is great, but I like to pair Inject w/ Double for on-the-fly setups. defmodule MyApplicationTest do use ExUnit.Case, async: true import Inject, only: [register: 2] import Double test &quot;use my stub for this test&quot; do register(File, stub(File, :open, fn(_, _) -&gt; {:ok, nil} end)) {:ok, nil} = MyApplication.process() end end Shared Mode If you want to inject a dependency that will be shared by all processes, you can do so by passing the shared: true option. This can be useful if you have background processing. This is only recommended for tests that do not run async. register(File, FileStub, shared: true)"},{"ref":"readme.html#todo","title":"Inject - TODO","type":"extras","doc":"Add allow/1 for enabling another process to use registrations from the current test."}]